import { DynamicModule, Module } from '@nestjs/common';

import { createMeilliOptions } from '@/modules/meilisearch/helpers';
import { MeilliService } from '@/modules/meilisearch/meilli.service';
import { MelliConfig } from '@/modules/meilisearch/types';

@Module({})
export class MeilliModule {
    static forRoot(configRegister: () => MelliConfig): DynamicModule {
        return {
            global: true,
            module: MeilliModule,
            providers: [
                {
                    provide: MeilliService,
                    useFactory: async () => {
                        const service = new MeilliService(
                            await createMeilliOptions(configRegister()),
                        );
                        service.createClients();
                        return service;
                    },
                },
            ],
            exports: [MeilliService],
        };
    }
}
